from vcCommand import *   
from vcHelpers.Output import *

app = getApplication()
sim = getSimulation()

def first_state():
  global copyFrom_Comp, copyFrom_Process, selection_Prop, pasteInto_CompList, copyPaste_Prop, text1, text2
  
  copyFrom_Comp = getProperty('CopyProcessFrom')
  if not copyFrom_Comp : copyFrom_Comp = createProperty('Ref<Node>','CopyProcessFrom')
  
  copyFrom_Process = getProperty('ProcessToCopy')
  if not copyFrom_Process: copyFrom_Process = createProperty(VC_STRING, 'ProcessToCopy', VC_PROPERTY_STEP)

  selComp = GetSelectedComponent() 
  if selComp != None :
    copyFrom_Comp.Value = selComp
    selectComp_CopyFrom(copyFrom_Comp)

  selection_Prop = getProperty('PasteInto')
  if not selection_Prop :
    selection_Prop = createProperty(VC_STRING, 'PasteInto', VC_PROPERTY_STEP)
    selection_Prop.StepValues = ['AllProcessesWithSameName','ProductSelection']
    selection_Prop.Value = 'AllProcessesWithSameName'

  pasteInto_CompList = getProperty('PasteProcessInto')
  if not pasteInto_CompList : pasteInto_CompList = createProperty('List<Ref<Node> >', 'PasteProcessInto')
  
  text1 = getProperty('If no Process with this name exists')
  if not text1 : 
    text1 = createProperty(VC_BUTTON, 'If no Process with this name exists')
  text1.WritableWhenConnected = False
  text1.WritableWhenDisconnected = False
  text1.WritableWhenSimulating = False
  text2 = getProperty('a new one will be added')
  if not text2 : text2 = createProperty(VC_BUTTON, 'a new one will be added')
  text2.WritableWhenConnected = False
  text2.WritableWhenDisconnected = False
  text2.WritableWhenSimulating = False

  copyPaste_Prop = getProperty('CopyPaste Process')
  if not copyPaste_Prop : copyPaste_Prop = createProperty(VC_BUTTON, 'CopyPaste Process')

  selection_Prop.OnChanged = setSelection
  copyPaste_Prop.OnChanged = CopyPaste_Process
  copyFrom_Comp.OnChanged = selectComp_CopyFrom
  setSelection(selection_Prop)

  executeInActionPanel()


def GetSelectedComponent():
  comps = app.SelectionManager.getSelection(VC_SELECTION_COMPONENT)
  
  if len(comps) > 0:
    return comps[0]
  
  nodes = app.SelectionManager.getSelection(VC_SELECTION_PARENTNODE)
  
  if len(nodes) == 0:
    return None
  
  return nodes[0].Component
  
def selectComp_CopyFrom(arg):
  global copyFrom_Comp, copyFrom_Process, selection_Prop, pasteInto_CompList, copyPaste_Prop
  copyProcesses = []
  copyFrom_Process.Value = ""
  if copyFrom_Comp.Value != None:
    copyComp = copyFrom_Comp.Value
    copyProcExec = copyComp.findBehavioursByType(VC_PROCESSEXECUTOR)
    if copyProcExec == []:
      info("Component", copyFrom_Comp.Name, "doesn't have a process executor")
      return
    else :
      for processExec in copyProcExec:
        for routine in processExec.Processes:
          copyProcesses.append(routine.Name)
      copyFrom_Process.StepValues = copyProcesses
      copyFrom_Process.Value = copyProcesses[0]
      if len(copyProcesses) == 1:
        copyFrom_Process.WritableWhenConnected = False
        copyFrom_Process.WritableWhenDisconnected = False
      else :
        copyFrom_Process.WritableWhenConnected = True
        copyFrom_Process.WritableWhenDisconnected = True

  
def CopyPaste_Process(arg):
  global copyFrom_Comp, copyFrom_Process, selection_Prop, pasteInto_CompList, copyPaste_Prop
  pasteInto_CompList = getProperty('PasteProcessInto')
  copyRoutine = None
  pasteCompList = []
  
  #select Routine to copy
  if copyFrom_Comp.Value != None:
    copyComp = copyFrom_Comp.Value
    copyProcExecList = copyComp.findBehavioursByType(VC_PROCESSEXECUTOR)
    if copyProcExecList == []:
      info("Component", copyFrom_Comp.Name, "doesn't have a process executor")
    else : 
      for procExec in copyProcExecList:
        for routines in procExec.Processes: 
          if routines.Name == copyFrom_Process.Value : 
            copyRoutine = routines
            break
  else : 
    info("Please select a component from which to copy the process")
  
  #select component(s) where to paste routine
  if selection_Prop.Value == "ProductSelection":
    if pasteInto_CompList.Value != []:
      pasteCompList = pasteInto_CompList.Value
    else : 
      info("Please select components in which the process will be pasted")
  else:
    for comps in app.Components :
      for procExe in comps.findBehavioursByType(VC_PROCESSEXECUTOR):
        for routines in procExe.Processes :
          if routines.Name == copyRoutine.Name: pasteCompList.append(comps)
    
  
  
  #Copy-Paste
  if copyRoutine and pasteCompList:
    for pasteComp in (pasteCompL for pasteCompL in pasteCompList if pasteCompL != copyComp) :
      pasteProcExecList = pasteComp.findBehavioursByType(VC_PROCESSEXECUTOR)
      if pasteProcExecList == []:
        info("Component", pasteComp.Name, "doesn't have a process executor")
        continue
      else:
        for pasteProcExec in pasteProcExecList:
          #if more than one ProcessExecutor :
          #-> "ProductSelection" : add Process in all ProcessExecutors
          #-> "AllProcessesWithSameName" : paste process in all Processes with the same name
          routineExists = False
          for pasteProcess in pasteProcExec.Processes:
            if pasteProcess.Name == copyRoutine.Name :
              pasteProcExec.deleteProcess(pasteProcess)
              routineExists = True
              break
          if selection_Prop.Value == "AllProcessesWithSameName" and routineExists == False:
            break
          else :
            pasteRoutine = pasteProcExec.addProcess(copyRoutine.Name)
            
            #Variables
            for copyProp in copyRoutine.Properties:
              pasteProp = pasteRoutine.createProperty(copyProp.Type, copyProp.Name)
            
            #Requirements
            for copyReqStatement in copyRoutine.Requirements.Statements :
              pasteReqStatement = pasteRoutine.Requirements.addStatement(copyReqStatement.Type, -1)
              
              for index,copyReqProp in enumerate(copyReqStatement.Properties) :
                pasteReqStatement.Properties[index].Value = copyReqStatement.Properties[index].Value
            
            #Statements
            addStatements(copyRoutine, pasteRoutine, pasteComp)
 
  
def addStatements(fromRoutine, toRoutine, toComp):
  global copyFrom_Comp, copyFrom_Process, selection_Prop, pasteInto_CompList, copyPaste_Prop
  for fromStatement in fromRoutine.Statements :
    if fromStatement.Type == VC_STATEMENT_PROCESS : 
      info("Can't copy Custom Process Statement")
      toStatement = toRoutine.addStatement(VC_STATEMENT_COMMENT, -1)
      toStatement.Comment = "Placeholder : Custom Process Statement"
      continue
    elif fromStatement.Type == VC_STATEMENT_MOVEJOINT and not toComp.findBehavioursByType(VC_SERVOCONTROLLER): 
      info("Component", toComp.Name, "doesn't have a Controller - No MoveJoint Statement added")
      toStatement = toRoutine.addStatement(VC_STATEMENT_COMMENT, -1)
      toStatement.Comment = "Placeholder : MoveJoint" 
      continue
    else :
      toStatement = toRoutine.addStatement(fromStatement.Type, -1)
      selectSelfComp, signalSelfComp, controllerFound = False, False, False
      toBehaviour, toProp = None, None
      timeSourceProp = ""
      for index, fromProp in enumerate(fromStatement.Properties) :
        #Delay or Work-Statement -> Time distribution
        if fromProp.Type == VC_DISTRIBUTION and timeSourceProp == "Distribution" :
          if fromProp.Distribution.startswith(("normal","lognormal","uniform","exponential","gamma","triangular","weibull")):
            toStatement.Properties[index].Distribution = fromProp.Distribution
            toStatement.Properties[index].RandomStream = fromProp.RandomStream
            continue

        toStatement.Properties[index].Value = fromProp.Value

        if fromProp.Name == "TimeSource" and fromProp.Value == 0: #VC_TIMESOURCE_DISTRIBUTION
          timeSourceProp = "Distribution"
        elif fromProp.Name == "TimeSource" and fromProp.Value == 1: #VC_TIMESOURCE_EXPRESSION
          timeSourceProp = "Expression"

        #find Frame
        if fromProp.Type == 'Ref<FrameFeature>' and fromProp.Value != None: #"Frame" in fromProp.Name and fromProp.Value != None:
          fList = [f.Name for f in toStatement.Properties[index].StepValues[1:]]
          if fromProp.Value.Name in fList:
            toFeature = toStatement.Properties[index].StepValues[fList.index(fromProp.Value.Name)+1]
            toStatement.Properties[index].Value = toFeature
          else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Frame not found")
          
          #find Container
        elif "Container" in fromProp.Name and fromProp.Value != None:
          cList = [c.Name for c in toStatement.Properties[index].StepValues[1:]]
          if fromProp.Value.Name in cList:
            toContainer = toStatement.Properties[index].StepValues[cList.index(fromProp.Value.Name)+1]
            toStatement.Properties[index].Value = toContainer
          else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Frame not found")
          
          #find Statistics
        elif fromProp.Type == 'Ref<Statistics>' and fromProp.Value != None: 
          sList = [s.Name for s in toStatement.Properties[index].StepValues[1:]]
          if fromProp.Value.Name in sList:
            toStatistic = toStatement.Properties[index].StepValues[sList.index(fromProp.Value.Name)+1]
            toStatement.Properties[index].Value = toStatistic
          else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Statistics not found")
            
          #sendSignal
          #waitSignal
        elif fromStatement.Type == VC_STATEMENT_SENDSIGNAL or fromStatement.Type == VC_STATEMENT_WAITSIGNAL :
          if fromProp.Name == "Component" and fromProp.Value == None : 
            signalSelfComp = True
          elif fromProp.Name == "Signal" and signalSelfComp and fromProp.Value != None:
            sList = [s.Name for s in toStatement.Properties[index].StepValues[1:]]
            if fromProp.Value.Name in sList:
              toSignal = toStatement.Properties[index].StepValues[sList.index(fromProp.Value.Name)+1]
              toStatement.Properties[index].Value = toSignal
            else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Signal not found")
          
          #MoveJoint
        elif fromStatement.Type == VC_STATEMENT_MOVEJOINT and toComp.findBehavioursByType(VC_SERVOCONTROLLER): 
          if fromProp.Name == "Controller" and fromProp.Value != None :
            contollerList = [c.Name for c in toStatement.Properties[index].StepValues[1:]]
            if fromProp.Value.Name in contollerList:
              #print fromProp.Value.Name, toStatement.Properties[index].StepValues[contollerList.index(fromProp.Value.Name)+1].Name
              toStatement.Properties[index].Value = toStatement.Properties[index].StepValues[contollerList.index(fromProp.Value.Name)+1]
              controllerFound = True
            else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Controller not found")
            
          elif fromProp.Name == "Joint" and fromProp.Value != None and controllerFound:
            jointList = [j.Name for j in toStatement.Properties[index].StepValues[1:]]
            if fromProp.Value.Name in jointList:
              toStatement.Properties[index].Value = toStatement.Properties[index].StepValues[jointList.index(fromProp.Value.Name)+1]
            else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Joint not found")
          
          #find Behaviours/Properties from Component
        elif fromProp.Name == "SelectedComponent" and fromProp.Value == None: 
          selectSelfComp = True #in this component
        elif selectSelfComp and fromProp.Name == "SelectedBehavior" and fromProp.Value != None :
          toBehaviour = toComp.findBehaviour(fromProp.Value.Name)
          if toBehaviour : toStatement.Properties[index].Value = toBehaviour
          else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Behaviour not found")
        elif selectSelfComp and fromProp.Name == "SelectedProperty" and fromProp.Value != None :
          if not toBehaviour : 
            toProp = toComp.getProperty(fromProp.Value.Name)
          else :
            toProp = [getP for getP in toBehaviour.Properties if getP.Name == fromProp.Value.Name][0]
          if toProp : toStatement.Properties[index].Value = toProp
          else : info(toComp.Name,"-",toStatement.Type, "-",toStatement.Properties[index].Name, "- Property not found")
        
        #Product Filter
        if fromProp.Name == "IsFilterVisible" and fromStatement.Filter.IsEnabled: 
          addProductFilter(fromStatement, toStatement)

      
      #if statements -> define scopes
      if fromStatement.Type == VC_STATEMENT_PROCESSIF:
        #then
        addStatements(fromStatement.ThenScope, toStatement.ThenScope, toComp)
        #else
        addStatements(fromStatement.ElseScope, toStatement.ElseScope, toComp)
        
      elif fromStatement.Type == VC_STATEMENT_PROCESSWHILE:
        addStatements(fromStatement.Scope, toStatement.Scope, toComp)
        
      elif fromStatement.Type == VC_STATEMENT_SWITCHCASE:
        #caseScope
        for fromCase in fromStatement.Cases:
          toCase = toStatement.addCase()
          toCase.CaseCondition = fromCase.CaseCondition
          addStatements(fromCase, toCase, toComp)


def addProductFilter(fromStatement, toStatement):
  global copyFrom_Comp, copyFrom_Process, selection_Prop, pasteInto_CompList, copyPaste_Prop
  fromFilter = fromStatement.Filter
  toFilter = toStatement.setFilter(fromFilter.Type)
  #Filter Type
  #0 -> VC_FILTER_ACCEPTALL (no Filter)
  #1 -> VC_FILTER_COMBINATION (different filters with "and"/"or" operation)
  #2 -> VC_FILTER_PRODUCTPROPERTY 
  #3 -> VC_FILTER_PRODUCTTYPE (?)
  #4 -> VC_FILTER_CONFIGURABLEPRODUCTTYPE (Product Type)
  #5 -> VC_FILTER_SPECIFICPRODUCT
  #6 -> VC_FILTER_EXPRESSION
  
  if fromFilter.Type == 1 : #VC_FILTER_COMBINATION
    
    combiSize = fromFilter.Filters.size()
    for filterIndex in range(combiSize):
      fromCombiFilter = fromFilter.Filters.get(filterIndex)
      toCombiFilter = toFilter.insertFilter(filterIndex, fromCombiFilter.Filter.Type, fromCombiFilter.Operation)
      setFilterType(fromCombiFilter.Filter.Type,fromCombiFilter.Filter,toCombiFilter.Filter)

  else :
    setFilterType(fromFilter.Type,fromFilter,toFilter)
  
  
def setFilterType(type,fromFilter,toFilter):
  global copyFrom_Comp, copyFrom_Process, selection_Prop, pasteInto_CompList, copyPaste_Prop
  if type == 4: # VC_FILTER_CONFIGURABLEPRODUCTTYPE 
    toFilter.Name = fromFilter.Name
    toFilter.AcceptedProductTypes = fromFilter.AcceptedProductTypes
    toFilter.AcceptedFlowGroups = fromFilter.AcceptedFlowGroups
    
  elif type == 2 : #VC_FILTER_PRODUCTPROPERTY
    toFilter.Name = fromFilter.Name
    toFilter.TargetProperty = fromFilter.TargetProperty
    toFilter.Operator = fromFilter.Operator
    toFilter.ComparisonValue = fromFilter.ComparisonValue
    toFilter.FilterDiagnosticsMode = fromFilter.FilterDiagnosticsMode
    
  elif type == 6 : #VC_FILTER_EXPRESSION
    toFilter.Name = fromFilter.Name
    toFilter.ProductAccessor = fromFilter.ProductAccessor
    toFilter.Expression = fromFilter.Expression
    toFilter.FilterDiagnosticsMode = fromFilter.FilterDiagnosticsMode
    
  elif type == 5 : #VC_FILTER_SPECIFICPRODUCT
    toFilter.Name = fromFilter.Name
    toFilter.ProductVariableName = fromFilter.ProductVariableName
    toFilter.CompareMode = fromFilter.CompareMode
  
  toFilter.IsEnabled = fromFilter.IsEnabled


def setSelection(arg):
  selection_Prop = getProperty('PasteInto')
  pasteInto_CompList = getProperty('PasteProcessInto')
  if selection_Prop.Value == "ProductSelection":
    pasteInto_CompList.IsVisible = True
    text1.IsVisible = True
    text2.IsVisible = True
  else :
    pasteInto_CompList.IsVisible = False
    text1.IsVisible = False
    text2.IsVisible = False

addState( first_state )